<template>
    <div class="the-bar-edit-bar-link">
        <Link :editor="editor"/>
        <bubble-menu class="the-editor-bubble-menu" :tippy-options="{placement: 'bottom'}" :editor="editor" plugin-key="link-preview" :should-show="shouldShowPreview">
            <div style="display: flex; gap: 4px; align-items: baseline;">
                <a style="max-width: 30ch;overflow-x:hidden;text-overflow: ellipsis;text-wrap: nowrap;" :href="preview">{{preview}}</a>
                <button type="button" class="the-editor-bubble-menu-button" @click="()=>{getCurrentUrl();edit_link=true}"><pencil/></button>
            </div>
        </bubble-menu>
        <bubble-menu class="the-editor-bubble-menu" :editor="editor" plugin-key="link-bubble" :should-show="shouldShowBar" :tippy-options="bubbleConfig">
           <div style="display: flex; flex-direction: column; gap: 2px;">
                <label class="the-editor-bubble-menu-label">Edit Link</label>
                <label class="the-editor-bubble-menu-label">
                    <span>URL :</span>
                    <input ref="focus_input" class="the-edit-bar-input" @keypress.enter="setLink" v-model="state.current_url" placeholder="URL" />
                </label>
                <label class="the-editor-bubble-menu-label">
                    Text :
                    <input class="the-edit-bar-input" @keypress.enter="setLink" v-model="state.current_text" placeholder="Text" />
                </label>
                <div style="display: flex; flex-direction: row-reverse; gap: 4px;">
                    <button type="button" class="the-editor-bubble-menu-button" @click="setLink">apply</button>
                    <button type="button" class="the-editor-bubble-menu-button" @click="cancel">cancel</button>
                    <div style="flex-grow: 1;"></div>
                    <button type="button" class="the-editor-bubble-menu-button" @click="unLink">unlink</button>
                </div>
            </div>
        </bubble-menu>
    </div>
</template>

<script setup lang="ts">
import type { Editor } from '@tiptap/core';
import { isMarkActive } from '@tiptap/core';
import type { TheEditor } from '../TheEditor';
import { BubbleMenu } from '@tiptap/vue-3';
import {Props as TippyProps} from 'tippy.js'
import makeButton from '../makeButton';
import makeIcon from '../makeIcon';
import { computed, reactive, ref, onMounted, onBeforeUnmount} from 'vue'


const props = defineProps<{
    editor: TheEditor,
}>()

const pencil = makeIcon('pencil', {size: 12})

const focus_input = ref<HTMLElement>()

const edit_link = ref(false)
const customEventListener = () => {
        // Add a link
        getCurrentUrl()
        // The bubble menu can only show up if the selection or content changes --
        // so we'll select all the text and then re-select the original selection in case the
        // selection isn't altered by getting the URL
        let { from, to } = props.editor.state.selection
        props.editor.commands.selectAll()
        props.editor.commands.setTextSelection({ from: from, to: to })
        edit_link.value = true
    }

onMounted(()=>{
    // Add the ctrl+k shortcut
    //@ts-ignore  We can't custom emitted events from the editor, but we need one here to tie the UI to the editor
    props.editor.on('customEvent:TriggerLinkEditor', customEventListener)
})
onBeforeUnmount(()=>{
    //@ts-ignore 
    props.editor.off('customEvent:TriggerLinkEditor', customEventListener)
})

const state = reactive({
    original_url: '',
    current_url: '',
    current_text: '',
})



const shouldShowBar = (ed: {editor: Editor, from: number, to: number}) => {
    
    if(ed && edit_link.value){
        edit_link.value = false
        return true
    }
    return false
}
const preview = ref('')
const shouldShowPreview = (ed: {editor: Editor, from: number, to: number}) => {
    if (isMarkActive(ed.editor.view.state, 'link')){
        // get the number between ed.from and ed.to
        let loc = Math.floor((ed.from + ed.to) / 2)
        preview.value = ed.editor.state.doc.resolve(loc).marks().find(mark => mark.type.name === 'link')?.attrs.href||''
        return true
    }
    return false
}

const btn_enabled = computed(() => props.editor.can().toggleLink({ href: '' }))
const btn_active = computed(() => props.editor.isActive("link"))


const getCurrentUrl = () => {
    props.editor.chain().focus().extendMarkRange('link').run()

    const editor_state = props.editor.state
    if (!editor_state) return ''

    // get marks, if any from selected area
    let { from, to } = editor_state.selection
    let marks: any[] = [] 
    let textnodes: any[] = []
    editor_state.doc.nodesBetween(from, to, (node) => {
        if (node.type.name == 'text') {
            textnodes.push(node)
        }
        marks = [...marks, ...node.marks]
    })

    // Sets the URL to the FIRST link we see (in case we selected several)
    const mark = marks.find((markItem) => markItem.type.name === 'link')
    const current_url = (mark && mark.attrs.href) ? mark.attrs.href : ''
    if (textnodes.length !== 0) {
        let textgrab = editor_state.doc.textBetween(from, to, ' ')
        // Did we accidentally grab tailing whitespace?
        let leading_whitespace = textgrab.match(/^\s+/)
        if (leading_whitespace) {
            let len = leading_whitespace[0].length
            from += len
            textgrab = textgrab.slice(len)
        }
        let trailing_whitespace = textgrab.match(/\s+$/)
        if (trailing_whitespace) {
            let len = trailing_whitespace[0].length
            to -= len
        }

        // Adjust Selection
        props.editor.commands.setTextSelection({ from: from, to: to })
        let txt = editor_state.doc.textBetween(from, to)
        state.current_text = (txt == current_url && current_url!=='') ? '' : txt
    }
    else if (textnodes.length == 0) {
        // We're running this with nothing selected, so we'll insert a new link, select it, and let the user edit it
        state.current_text = ''
        state.current_url = ''
        props.editor.commands.setTextSelection({ from: from, to: to })
    }
    state.original_url = current_url
    state.current_url = current_url
}
const cancel = () => {
    props.editor.chain().focus().extendMarkRange('link').run()
    edit_link.value = false
}

const escape = (e: KeyboardEvent) => {
    if (e.key === 'Escape') {
        cancel()
    }
}
const setLink = () => {
    if (state.current_url !== '') {
        let commands = props.editor.chain().focus().extendMarkRange('link')
        commands = commands?.insertContent(`<a href="${state.current_url}">${state.current_text === '' ? state.current_url : state.current_text}</a>`)
        commands?.run()
        edit_link.value = false
    }
    else{
        unLink()
    }
}

const unLink = () => {
    props.editor.chain().focus().extendMarkRange('link').unsetLink().run()
    edit_link.value = false
}

const bubbleConfig:Partial<TippyProps> = {
    placement: 'bottom',
    onShow: () => {
            setTimeout(() => focus_input.value?.focus(), 50)
            // Escape to cancel
            window.addEventListener('keydown', escape)
    },
    onHide: () => {
        edit_link.value = false
        // stop listening for escape
        window.removeEventListener('keydown', escape)
    }
}

const Link = makeButton({
    title: 'edit or insert link',
    shortcut: 'Ctrl + K',
    content: makeIcon('link'),
    active: _e=>btn_active.value,
    enabled: _e=>btn_enabled.value,
    action: (_e) => {
        getCurrentUrl()
        edit_link.value = true
    }
})

</script>
